<template>
  <div id="air-info">
    <div class="fan-speed">
      <img src="@/assets/images/airInfo/fan-v-icon.png" alt=""/>
      <div class="fan-info" @click="handleOpenChart">
        <div class="input-fan"><span>风速</span>{{ windSpeed }}m/s</div>
      </div>
    </div>
      <item-info
          v-for="item in airList"
          :key="item.equipmentId"
          :wp="item"
          :icon="item.icon"
          :name="item.name"
          :unit="item.unit"
          @click="handleOpenAirChart(item)"
      />

    <div class="digital-tunnel">
      <el-dialog :close-on-click-modal="false" v-model="isWindSpeedVisited" :title="'风速监控数据'" width="2175px" :modal="false">
        <div class="left-top-icon"></div>
        <div class="right-top-icon"></div>
        <div class="chat-dialog">
          <div id="containerWind"></div>
          <div style="width: 1px;"></div>
        </div>
        <div class="time-select">
          <time-range-btn
              :buttonList="timeList"
              v-model="selectTimeButton"
              @select="timeSelect"
          />
        </div>
        <div class="left-bottom-icon"></div>
        <div class="right-bottom-icon"></div>
      </el-dialog>
    </div>
    <div class="digital-tunnel">
      <el-dialog :close-on-click-modal="false" v-model="isAirVisited" :title="airTitle+'监控数据'" width="2175px" :modal="false">
        <div class="left-top-icon"></div>
        <div class="right-top-icon"></div>
        <div class="chat-dialog">
          <div id="containerAir"></div>
          <div style="width: 1px;"></div>
        </div>
        <div class="time-select">
          <time-range-btn
              :buttonList="timeList"
              v-model="selectTimeButton"
              @select="timeSelect"
          />
        </div>
        <div class="left-bottom-icon"></div>
        <div class="right-bottom-icon"></div>
      </el-dialog>
    </div>

  </div>
</template>

<script setup>
import ItemInfo from "./childComps/ItemInfo.vue";
import TimeRangeBtn from "@/components/timeRangeBtn/index.vue"
import * as echarts from 'echarts';
import {getEchartsInfo} from "../../../api/largeScreen";

let myEcharts = reactive({});
let myAirEcharts = reactive({});
const props = defineProps({
  list: Array,
  airData: Array
});
const windSpeed = ref('')
const windSpeedId = ref(0)
const airTitle = ref('')
const airList = ref([])
const timeList = ref(["年", "月", "日"]);
const selectTimeButton = ref(2);
const isWindSpeedVisited = ref(false);
const isAirVisited = ref(false);
watch(() => props.list, (now) => {
  airList.value?.forEach(item => {
    now.forEach(newItem => {
      if (item.equipmentId === newItem.equipmentId) {
        item.value = newItem.value
      }
    })
  })
}, {deep: true});
watch(() => props.airData, (now) => {
  if(now.sensorList.length===0){
    airList.value=[]
  }else {
    getAirInfo(now.sensorList)
  }
}, {deep: true});
const getChartInfo = (equipmentId) => {
  getEchartsInfo(equipmentId).then(res => {
    if (res?.code === 1000) {
      isWindSpeedVisited.value = true
      nextTick(() => {
        initChart(res.data.dates, res.data.values)
      })
    }
  })
}
const getGasChartInfo = (equipmentId) => {
  getEchartsInfo(equipmentId).then(res => {
    if (res?.code === 1000) {
      isAirVisited.value = true
      nextTick(() => {
        initAirChart(res.data.dates, res.data.values)
      })
    }
  })
}
const handleOpenChart = () => {
  // isWindSpeedVisited.value = true
  getChartInfo(windSpeedId.value)
}

const handleOpenAirChart = (item) => {
  // isAirVisited.value = true
  airTitle.value = item.name
  getGasChartInfo(item.equipmentId)
  // nextTick(() => {
  //   initAirChart()
  // })
}
const timeSelect = (index) => {
  console.log('选择时间', index)
  if (index === 0) {
    console.log('--年')
  } else if (index === 1) {
    console.log('--月')
  } else if (index === 2) {
    console.log('--日')
  }
};
const changeData = (item) => {
  return {
    equipmentId: item.equipmentId,
    icon: changeIcon(item.equipmentType),
    name: item.equipmentName.slice(0, 2),
    max: 120,
    value: item.value,
    point: item.valueThreshold,
    unit: item.unit
  }
}
const changeIcon = (type) => {
  switch (type) {
    case "dust":
      return 'dust-icon.png';
    case "oxygen":
      return 'o2-icon.png';
    case "temperature":
      return 'tempture-icon.png';
    case "humidness":
      return 'water-icon.png';
  }
}
const getAirInfo = (now) => {
  if (now === null) return;
  let airObj = {}
  let airArr = []
  now?.map(item => {
    if (item.equipmentType === "dust" || item.equipmentType === "oxygen" || item.equipmentType === "temperature" || item.equipmentType === "humidness") {
      airObj = changeData(item)
      airArr.push(airObj)
    } else if (item.equipmentType === "windSpeed") {
      windSpeedId.value = item.equipmentId
      windSpeed.value = item.value
    }
  })
  airArr.push(airArr.shift())
  airList.value = airArr
}
const initChart = (type, values) => {
  //3.初始化container容器
  myEcharts = echarts.init(document.getElementById('containerWind'));
  //5.传入数据
  let option = {
    //图例
    legend: {
      // left: 0,
      textStyle: {
        color: '#FFFFFF',
        fontSize: 40
      },
      itemWidth: 70,
      itemHeight: 5,
      icon: "rect",
    },
    //离容器四侧的距离
    grid: {
      left: 0, // 左边距
      right: 20, // 右边距
      top: 80, // 顶边距
      bottom: 0, // 底边距
      containLabel: true,
    },
    //提示框组件
    tooltip: {
      show: true,
      trigger: 'axis',
      backgroundColor: "transparent", // 设置背景颜色为透明
      borderColor: "transparent", // 设置边框颜色为透明
      padding: 0, // 设置内边距为0
      textStyle: {
        fontSize: 40
      },
      formatter: function (params) {
        let content = `
          <div style="background: linear-gradient(180deg, #254062 0%, rgba(20,36,51,0.3) 100%);;border: 2px solid #6087BA;border-radius: 4px;padding: 8px 16px;">
            <div style="font-size: 52px;font-family: PingFang SC-Regular, PingFang SC;font-weight: 400;color: #EFEEEE;margin-bottom: 8px;">${params[0].name}</div>
            <div style="font-size: 48px;line-height: 48px;font-family: Bebas Neue-Regular, Bebas Neue;font-weight: 400;"><span style="color: #FFFFFF">进风口: </span><span style="background: linear-gradient(180deg, #F5B85F 0%, #FFFFFF 100%);-webkit-background-clip: text;-webkit-text-fill-color: transparent;">${params[0].value}</span></div>
            <div style="font-size: 48px;line-height: 48px;font-family: Bebas Neue-Regular, Bebas Neue;font-weight: 400;margin-top: 30px"><span style="color: #FFFFFF">出风口: </span><span style="background: linear-gradient(180deg, #F5B85F 0%, #FFFFFF 100%);-webkit-background-clip: text;-webkit-text-fill-color: transparent;">${params[1].value}</span></div>
          </div>`;
        return content;
      },
    },
    toolbox: {
      show: false,
      right: 10,
      feature: {
        dataZoom: {
          yAxisIndex: 'none'
        }
      }
    },
    dataZoom: [{
      type: 'inside'
    }],
    //X轴
    xAxis: {
      type: 'category',
      // data: ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00', '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00'],
      data:type,
      axisLabel: {
        textStyle: {
          fontSize: 45,
          color: '#D6F1FA'
        },
      },
    },
    //Y轴
    yAxis: {
      type: 'value',
      axisLabel: {
        textStyle: {
          fontSize: 45,
          color: '#D6F1FA'
        },
      },
    },
    //配置项
    series: [
      {
        // data: [3, 85, 47, 92, 17, 76, 69, 25, 56, 12, 89, 34, 71, 43, 67, 20, 98, 72, 19, 61, 31, 49, 81, 63],
        data:values,
        type: 'line',
        smooth: true,
        symbolSize: 24,
        lineStyle: {
          width: 5
        }
      }
    ]
  }

  myEcharts.setOption(option);
  //图表大小自适应窗口大小变化
  window.onresize = () => {
    myEcharts.resize();
  }
}
const initAirChart = (type, values) => {
  //3.初始化container容器
  myAirEcharts = echarts.init(document.getElementById('containerAir'));
  //5.传入数据
  let option = {
    //图例
    legend: {
      // left: 0,
      textStyle: {
        color: '#FFFFFF',
        fontSize: 40
      }
    },
    //离容器四侧的距离
    grid: {
      left: 0, // 左边距
      right: 20, // 右边距
      top: 80, // 顶边距
      bottom: 0, // 底边距
      containLabel: true,
    },
    //提示框组件
    tooltip: {
      show: true,
      trigger: 'axis',
      backgroundColor: "transparent", // 设置背景颜色为透明
      borderColor: "transparent", // 设置边框颜色为透明
      padding: 0, // 设置内边距为0
      textStyle: {
        fontSize: 40
      },
      formatter: function (params) {
        let content = `
          <div style="background: linear-gradient(180deg, #254062 0%, rgba(20,36,51,0.3) 100%);;border: 2px solid #6087BA;border-radius: 4px;padding: 8px 16px;">
            <div style="font-size: 52px;font-family: PingFang SC-Regular, PingFang SC;font-weight: 400;color: #EFEEEE;margin-bottom: 8px;">${params[0].name}</div>
            <div style="font-size: 52px;line-height: 48px;font-family: Bebas Neue-Regular, Bebas Neue;font-weight: 400;"><span style="background: linear-gradient(180deg, #F5B85F 0%, #FFFFFF 100%);-webkit-background-clip: text;-webkit-text-fill-color: transparent;">${params[0].value}</span></div>
          </div>`;
        return content;
      },
    },
    toolbox: {
      show: false,
      right: 10,
      feature: {
        dataZoom: {
          yAxisIndex: 'none'
        }
      }
    },
    dataZoom: [{
      type: 'inside'
    }],
    //X轴
    xAxis: {
      type: 'category',
      // data: ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00', '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00', '24:00'],
      data:type,
      axisLabel: {
        textStyle: {
          fontSize: 45,
          color: '#D6F1FA'
        },
      },
    },
    //Y轴
    yAxis: {
      type: 'value',
      axisLabel: {
        textStyle: {
          fontSize: 45,
          color: '#D6F1FA'
        },
      },
    },
    //配置项
    series: [
      {
        // data: [56, 12, 89, 34, 71, 43, 67, 20, 98, 72, 19, 61, 3, 85, 47, 92, 17, 76, 69, 25, 31, 49, 81, 63],
        data:values,
        type: 'line',
        smooth: true,
        symbolSize: 24,
        lineStyle: {
          width: 5
        }
      }
    ]
  }
  myAirEcharts.setOption(option);
  //图表大小自适应窗口大小变化
  window.onresize = () => {
    myAirEcharts.resize();
  }
}

</script>

<style lang="scss" scoped>
#air-info {
  position: absolute;
  z-index: 100;
  width: 824px;
  height: 400px;
  top: 1003px;
  right: 72px;
  background-image: url(@/assets/images/airInfo/bg.png);
  padding: 25px 20px 0 21px;

  .fan-speed {
    display: flex;
    //height: 40px;
    font-size: 30px;
    font-family: MicrosoftYaHei;
    color: #ffffff;
    line-height: 40px;
    align-items: center;
    padding: 5px 0 5px 15px;
    margin-bottom: 25px;

    &:hover {
      //width: 790px;
      background: #2E5589;
      border-radius: 6px;
    }

    img {
      width: 29px;
      height: 34px;
    }

    .fan-info {
      flex: 1;
      display: flex;
      justify-content: flex-start;

      .input-fan {
        //margin: 0 26px;

        > span:first-child {
          margin-left: 25px;
          margin-right: 25px;
        }
      }
    }
  }
}
</style>
